import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

import CMFMemberFTestCase

class TestRegistration(CMFMemberFTestCase.CMFMemberFTestCase):

    def testJoinValidation(self):
        self.selenium.open('/portal/createMember')
        self.selenium.clickAndWait('form.button.register')
        res = self.selenium.verifyTextPresent('You did not enter a login name.','')
        self.failUnless(res == 'PASSED')
        res = self.selenium.verifyTextPresent('E-mail is required, please correct.','')
        self.failUnless(res == 'PASSED')
        res = self.selenium.verifyTextPresent('You did not enter a password.','')
        self.failUnless(res == 'PASSED')

        self.selenium.type('id', 'johndoe')
        self.selenium.type('email', 'john@doe.com')
        self.selenium.type('password', 'secret')
        self.selenium.clickAndWait('form.button.register')
        res = self.selenium.verifyTextPresent('Passwords do not match.', '')
        self.failUnless(res == 'PASSED')

        self.selenium.type('password', 'secret')
        self.selenium.type('confirm_password', 'secret')
        self.selenium.clickAndWait('form.button.register')
        res = self.selenium.verifyTextPresent('You have been registered.', '')
        self.failUnless(res == 'PASSED')
        res = self.selenium.verifyAttribute('log_in_button@value', 'Log in')
        self.failUnless(res == 'PASSED')

        self.selenium.clickAndWait('log_in_button')
        res = self.selenium.verifyTextPresent('Welcome! You are now logged in.', '')
        self.failUnless(res == 'PASSED')
        
        self.selenium.open('/portal/logout')
        self.selenium.open('/portal/createMember')
        self.selenium.type('id', 'johndoe')
        self.selenium.type('email', 'john@doe.com')
        self.selenium.type('password', 'secret')
        self.selenium.type('confirm_password', 'secret')
        self.selenium.clickAndWait('form.button.register')
        res = self.selenium.verifyTextPresent('The login name you selected is already in use or is not valid.', '')
        self.failUnless(res == 'PASSED')

        self.selenium.testComplete()
        

if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))
    framework()
else:
    from unittest import TestSuite, makeSuite
    def test_suite():
        suite = TestSuite()
        suite.addTest(makeSuite(TestRegistration))
        return suite
